controllermap.c File Reference
`#include <stdio.h>`
`#include <stdlib.h>`
`#include <string.h>`
`#include "SDL.h"`
Include dependency graph for controllermap.c:

Go to the source code of this file.

## Data Structures

struct | SDL_GameControllerExtendedBind
struct | AxisState

## Macros

#define | SCREEN_WIDTH 512
#define | SCREEN_HEIGHT 320
#define | MARKER_BUTTON 1
#define | MARKER_AXIS 2
#define | BINDING_COUNT (SDL_CONTROLLER_BUTTON_MAX + SDL_CONTROLLER_BINDING_AXIS_MAX)

## Enumerations

enum

{
SDL_CONTROLLER_BINDING_AXIS_LEFTX_NEGATIVE,
SDL_CONTROLLER_BINDING_AXIS_LEFTX_POSITIVE,
SDL_CONTROLLER_BINDING_AXIS_LEFTY_NEGATIVE,
SDL_CONTROLLER_BINDING_AXIS_LEFTY_POSITIVE,
SDL_CONTROLLER_BINDING_AXIS_RIGHTX_NEGATIVE,
SDL_CONTROLLER_BINDING_AXIS_RIGHTX_POSITIVE,
SDL_CONTROLLER_BINDING_AXIS_RIGHTY_NEGATIVE,
SDL_CONTROLLER_BINDING_AXIS_RIGHTY_POSITIVE,
SDL_CONTROLLER_BINDING_AXIS_TRIGGERLEFT,
SDL_CONTROLLER_BINDING_AXIS_TRIGGERRIGHT,
SDL_CONTROLLER_BINDING_AXIS_MAX
}

## Functions

SDL_Texture * | LoadTexture (SDL_Renderer *renderer, const char *file, SDL_bool transparent)
static int | StandardizeAxisValue (int nValue)
static void | SetCurrentBinding (int iBinding)
static SDL_bool | BBindingContainsBinding (const SDL_GameControllerExtendedBind *pBindingA, const SDL_GameControllerExtendedBind *pBindingB)
static void | ConfigureBinding (const SDL_GameControllerExtendedBind *pBinding)
static SDL_bool | BMergeAxisBindings (int iIndex)
static void | WatchJoystick (SDL_Joystick *joystick)
int | main (int argc, char *argv[])

## Variables

struct {
int x
int y
double angle
int marker
} | s_arrBindingDisplay [BINDING_COUNT]
static int | s_arrBindingOrder [BINDING_COUNT]
static SDL_GameControllerExtendedBind | s_arrBindings [BINDING_COUNT]
static int | s_nNumAxes
static AxisState * | s_arrAxisState
static int | s_iCurrentBinding
static Uint32 | s_unPendingAdvanceTime
static SDL_bool | s_bBindingComplete

## Macro Definition Documentation

## BINDING_COUNT

#define BINDING_COUNT (SDL_CONTROLLER_BUTTON_MAX + SDL_CONTROLLER_BINDING_AXIS_MAX)

Definition at line 50 of file controllermap.c.

Referenced by SetCurrentBinding().

## MARKER_AXIS

#define MARKER_AXIS 2

Definition at line 33 of file controllermap.c.

Referenced by WatchJoystick().

## MARKER_BUTTON

#define MARKER_BUTTON 1

Definition at line 32 of file controllermap.c.

Referenced by WatchJoystick().

## SCREEN_HEIGHT

#define SCREEN_HEIGHT 320

Definition at line 29 of file controllermap.c.

Referenced by WatchJoystick().

## SCREEN_WIDTH

#define SCREEN_WIDTH 512

Definition at line 28 of file controllermap.c.

Referenced by WatchJoystick().

## Enumeration Type Documentation

## anonymous enum

anonymous enum

Enumerator
SDL_CONTROLLER_BINDING_AXIS_LEFTX_NEGATIVE |
SDL_CONTROLLER_BINDING_AXIS_LEFTX_POSITIVE |
SDL_CONTROLLER_BINDING_AXIS_LEFTY_NEGATIVE |
SDL_CONTROLLER_BINDING_AXIS_LEFTY_POSITIVE |
SDL_CONTROLLER_BINDING_AXIS_RIGHTX_NEGATIVE |
SDL_CONTROLLER_BINDING_AXIS_RIGHTX_POSITIVE |
SDL_CONTROLLER_BINDING_AXIS_RIGHTY_NEGATIVE |
SDL_CONTROLLER_BINDING_AXIS_RIGHTY_POSITIVE |
SDL_CONTROLLER_BINDING_AXIS_TRIGGERLEFT |
SDL_CONTROLLER_BINDING_AXIS_TRIGGERRIGHT |
SDL_CONTROLLER_BINDING_AXIS_MAX |

Definition at line 35 of file controllermap.c.

{
SDL_CONTROLLER_BINDING_AXIS_LEFTX_NEGATIVE,
SDL_CONTROLLER_BINDING_AXIS_LEFTX_POSITIVE,
SDL_CONTROLLER_BINDING_AXIS_LEFTY_NEGATIVE,
SDL_CONTROLLER_BINDING_AXIS_LEFTY_POSITIVE,
SDL_CONTROLLER_BINDING_AXIS_RIGHTX_NEGATIVE,
SDL_CONTROLLER_BINDING_AXIS_RIGHTX_POSITIVE,
SDL_CONTROLLER_BINDING_AXIS_RIGHTY_NEGATIVE,
SDL_CONTROLLER_BINDING_AXIS_RIGHTY_POSITIVE,
SDL_CONTROLLER_BINDING_AXIS_TRIGGERLEFT,
SDL_CONTROLLER_BINDING_AXIS_TRIGGERRIGHT,
SDL_CONTROLLER_BINDING_AXIS_MAX,
};
SDL_CONTROLLER_BINDING_AXIS_RIGHTY_POSITIVE
Definition: controllermap.c:44
SDL_CONTROLLER_BINDING_AXIS_TRIGGERRIGHT
Definition: controllermap.c:46
SDL_CONTROLLER_BINDING_AXIS_MAX
Definition: controllermap.c:47
SDL_CONTROLLER_BINDING_AXIS_LEFTX_NEGATIVE
Definition: controllermap.c:37
SDL_CONTROLLER_BINDING_AXIS_TRIGGERLEFT
Definition: controllermap.c:45
SDL_CONTROLLER_BINDING_AXIS_LEFTY_NEGATIVE
Definition: controllermap.c:39
SDL_CONTROLLER_BINDING_AXIS_LEFTX_POSITIVE
Definition: controllermap.c:38
SDL_CONTROLLER_BINDING_AXIS_RIGHTX_POSITIVE
Definition: controllermap.c:42
SDL_CONTROLLER_BINDING_AXIS_RIGHTX_NEGATIVE
Definition: controllermap.c:41
SDL_CONTROLLER_BINDING_AXIS_RIGHTY_NEGATIVE
Definition: controllermap.c:43
SDL_CONTROLLER_BINDING_AXIS_LEFTY_POSITIVE
Definition: controllermap.c:40

## Function Documentation

## BBindingContainsBinding()

static SDL_bool BBindingContainsBinding | ( | const SDL_GameControllerExtendedBind * | pBindingA,
|  | const SDL_GameControllerExtendedBind * | pBindingB
| ) |  |

static

Definition at line 227 of file controllermap.c.

References SDL_GameControllerExtendedBind::axis, SDL_GameControllerExtendedBind::bindType, SDL_GameControllerExtendedBind::committed, SDL_CONTROLLER_BINDTYPE_AXIS, SDL_FALSE, SDL_max, SDL_memcmp, SDL_min, and SDL_GameControllerExtendedBind::value.

Referenced by ConfigureBinding().

{
if (pBindingA->bindType != pBindingB->bindType)
{
return SDL_FALSE;
}
switch (pBindingA->bindType)
{
case SDL_CONTROLLER_BINDTYPE_AXIS:
if (pBindingA->value.axis.axis != pBindingB->value.axis.axis) {
return SDL_FALSE;
}
if (!pBindingA->committed) {
return SDL_FALSE;
}
{
int minA = SDL_min(pBindingA->value.axis.axis_min, pBindingA->value.axis.axis_max);
int maxA = SDL_max(pBindingA->value.axis.axis_min, pBindingA->value.axis.axis_max);
int minB = SDL_min(pBindingB->value.axis.axis_min, pBindingB->value.axis.axis_max);
int maxB = SDL_max(pBindingB->value.axis.axis_min, pBindingB->value.axis.axis_max);
return (minA <= minB && maxA >= maxB);
}
/* Not reached */
default:
return SDL_memcmp(pBindingA, pBindingB, sizeof(*pBindingA)) == 0;
}
}
SDL_min
#define SDL_min(x, y)
Definition: SDL_stdinc.h:406
SDL_GameControllerExtendedBind::value
union SDL_GameControllerExtendedBind::@48 value
SDL_FALSE
Definition: SDL_stdinc.h:141
SDL_GameControllerExtendedBind::committed
SDL_bool committed
Definition: controllermap.c:134
SDL_max
#define SDL_max(x, y)
Definition: SDL_stdinc.h:407
SDL_memcmp
#define SDL_memcmp
Definition: SDL_dynapi_overrides.h:389
SDL_GameControllerExtendedBind::bindType
SDL_GameControllerBindType bindType
Definition: controllermap.c:116
SDL_GameControllerExtendedBind::axis
int axis
Definition: controllermap.c:122
SDL_CONTROLLER_BINDTYPE_AXIS
Definition: SDL_gamecontroller.h:65

## BMergeAxisBindings()

static SDL_bool BMergeAxisBindings | ( | int | iIndex | ) |

static

Definition at line 336 of file controllermap.c.

References SDL_GameControllerExtendedBind::axis, SDL_GameControllerExtendedBind::bindType, SDL_CONTROLLER_BINDTYPE_AXIS, SDL_CONTROLLER_BINDTYPE_NONE, SDL_FALSE, SDL_TRUE, and SDL_GameControllerExtendedBind::value.

Referenced by WatchJoystick().

{
SDL_GameControllerExtendedBind *pBindingA = &s_arrBindings[iIndex];
SDL_GameControllerExtendedBind *pBindingB = &s_arrBindings[iIndex+1];
if (pBindingA->bindType == SDL_CONTROLLER_BINDTYPE_AXIS &&
pBindingB->bindType == SDL_CONTROLLER_BINDTYPE_AXIS &&
pBindingA->value.axis.axis == pBindingB->value.axis.axis) {
if (pBindingA->value.axis.axis_min == pBindingB->value.axis.axis_min) {
pBindingA->value.axis.axis_min = pBindingA->value.axis.axis_max;
pBindingA->value.axis.axis_max = pBindingB->value.axis.axis_max;
pBindingB->bindType = SDL_CONTROLLER_BINDTYPE_NONE;
return SDL_TRUE;
}
}
return SDL_FALSE;
}
SDL_TRUE
Definition: SDL_stdinc.h:142
SDL_GameControllerExtendedBind::value
union SDL_GameControllerExtendedBind::@48 value
SDL_FALSE
Definition: SDL_stdinc.h:141
SDL_GameControllerExtendedBind
Definition: controllermap.c:114
SDL_GameControllerExtendedBind::bindType
SDL_GameControllerBindType bindType
Definition: controllermap.c:116
SDL_GameControllerExtendedBind::axis
int axis
Definition: controllermap.c:122
SDL_CONTROLLER_BINDTYPE_AXIS
Definition: SDL_gamecontroller.h:65
s_arrBindings
static SDL_GameControllerExtendedBind s_arrBindings[BINDING_COUNT]
Definition: controllermap.c:138
SDL_CONTROLLER_BINDTYPE_NONE
Definition: SDL_gamecontroller.h:63

## ConfigureBinding()

static void ConfigureBinding | ( | const SDL_GameControllerExtendedBind * | pBinding | ) |

static

Definition at line 256 of file controllermap.c.

References SDL_GameControllerExtendedBind::axis, BBindingContainsBinding(), SDL_GameControllerExtendedBind::bindType, SDL_GameControllerExtendedBind::button, SDL_GameControllerExtendedBind::committed, SDL_GameControllerExtendedBind::hat, s_arrBindingOrder, s_iCurrentBinding, s_unPendingAdvanceTime, SDL_arraysize, SDL_CONTROLLER_BINDTYPE_AXIS, SDL_CONTROLLER_BINDTYPE_BUTTON, SDL_CONTROLLER_BINDTYPE_HAT, SDL_CONTROLLER_BINDTYPE_NONE, SDL_CONTROLLER_BUTTON_A, SDL_CONTROLLER_BUTTON_B, SDL_CONTROLLER_BUTTON_DPAD_DOWN, SDL_CONTROLLER_BUTTON_DPAD_LEFT, SDL_CONTROLLER_BUTTON_DPAD_RIGHT, SDL_CONTROLLER_BUTTON_DPAD_UP, SDL_CONTROLLER_BUTTON_MAX, SDL_GetTicks(), SDL_Log, SetCurrentBinding(), and SDL_GameControllerExtendedBind::value.

Referenced by WatchJoystick().

{
SDL_GameControllerExtendedBind *pCurrent;
int iIndex;
int iCurrentElement = s_arrBindingOrder[s_iCurrentBinding];
/* Do we already have this binding? */
for (iIndex = 0; iIndex < SDL_arraysize(s_arrBindings); ++iIndex) {
pCurrent = &s_arrBindings[iIndex];
if (BBindingContainsBinding(pCurrent, pBinding)) {
if (iIndex == SDL_CONTROLLER_BUTTON_A && iCurrentElement != SDL_CONTROLLER_BUTTON_B) {
/* Skip to the next binding */
SetCurrentBinding(s_iCurrentBinding + 1);
return;
}
if (iIndex == SDL_CONTROLLER_BUTTON_B) {
/* Go back to the previous binding */
SetCurrentBinding(s_iCurrentBinding - 1);
return;
}
/* Already have this binding, ignore it */
return;
}
}
#ifdef DEBUG_CONTROLLERMAP
switch ( pBinding->bindType )
{
case SDL_CONTROLLER_BINDTYPE_NONE:
break;
case SDL_CONTROLLER_BINDTYPE_BUTTON:
SDL_Log("Configuring button binding for button %d\n", pBinding->value.button);
break;
case SDL_CONTROLLER_BINDTYPE_AXIS:
SDL_Log("Configuring axis binding for axis %d %d/%d committed = %s\n", pBinding->value.axis.axis, pBinding->value.axis.axis_min, pBinding->value.axis.axis_max, pBinding->committed ? "true" : "false");
break;
case SDL_CONTROLLER_BINDTYPE_HAT:
SDL_Log("Configuring hat binding for hat %d %d\n", pBinding->value.hat.hat, pBinding->value.hat.hat_mask);
break;
}
#endif /* DEBUG_CONTROLLERMAP */
/* Should the new binding override the existing one? */
pCurrent = &s_arrBindings[iCurrentElement];
if (pCurrent->bindType != SDL_CONTROLLER_BINDTYPE_NONE) {
SDL_bool bNativeDPad, bCurrentDPad;
SDL_bool bNativeAxis, bCurrentAxis;
bNativeDPad = (iCurrentElement == SDL_CONTROLLER_BUTTON_DPAD_UP ||
iCurrentElement == SDL_CONTROLLER_BUTTON_DPAD_DOWN ||
iCurrentElement == SDL_CONTROLLER_BUTTON_DPAD_LEFT ||
iCurrentElement == SDL_CONTROLLER_BUTTON_DPAD_RIGHT);
bCurrentDPad = (pCurrent->bindType == SDL_CONTROLLER_BINDTYPE_HAT);
if (bNativeDPad && bCurrentDPad) {
/* We already have a binding of the type we want, ignore the new one */
return;
}
bNativeAxis = (iCurrentElement >= SDL_CONTROLLER_BUTTON_MAX);
bCurrentAxis = (pCurrent->bindType == SDL_CONTROLLER_BINDTYPE_AXIS);
if (bNativeAxis == bCurrentAxis &&
(pBinding->bindType != SDL_CONTROLLER_BINDTYPE_AXIS ||
pBinding->value.axis.axis != pCurrent->value.axis.axis)) {
/* We already have a binding of the type we want, ignore the new one */
return;
}
}
*pCurrent = *pBinding;
if (pBinding->committed) {
s_unPendingAdvanceTime = SDL_GetTicks();
} else {
s_unPendingAdvanceTime = 0;
}
}
SetCurrentBinding
static void SetCurrentBinding(int iBinding)
Definition: controllermap.c:200
SDL_GameControllerExtendedBind::value
union SDL_GameControllerExtendedBind::@48 value
SDL_CONTROLLER_BUTTON_A
Definition: SDL_gamecontroller.h:304
SDL_GameControllerExtendedBind
Definition: controllermap.c:114
SDL_CONTROLLER_BUTTON_DPAD_RIGHT
Definition: SDL_gamecontroller.h:318
SDL_CONTROLLER_BUTTON_B
Definition: SDL_gamecontroller.h:305
SDL_GameControllerExtendedBind::committed
SDL_bool committed
Definition: controllermap.c:134
s_arrBindingOrder
static int s_arrBindingOrder[BINDING_COUNT]
Definition: controllermap.c:86
SDL_CONTROLLER_BINDTYPE_BUTTON
Definition: SDL_gamecontroller.h:64
BBindingContainsBinding
static SDL_bool BBindingContainsBinding(const SDL_GameControllerExtendedBind *pBindingA, const SDL_GameControllerExtendedBind *pBindingB)
Definition: controllermap.c:227
SDL_Log
#define SDL_Log
Definition: SDL_dynapi_overrides.h:31
s_unPendingAdvanceTime
static Uint32 s_unPendingAdvanceTime
Definition: controllermap.c:151
SDL_GetTicks
Uint32 SDL_GetTicks(void)
Get the number of milliseconds since the SDL library initialization.
s_iCurrentBinding
static int s_iCurrentBinding
Definition: controllermap.c:150
SDL_GameControllerExtendedBind::bindType
SDL_GameControllerBindType bindType
Definition: controllermap.c:116
SDL_CONTROLLER_BUTTON_MAX
Definition: SDL_gamecontroller.h:319
SDL_GameControllerExtendedBind::hat
int hat
Definition: controllermap.c:128
SDL_CONTROLLER_BUTTON_DPAD_UP
Definition: SDL_gamecontroller.h:315
SDL_bool
SDL_bool
Definition: SDL_stdinc.h:139
SDL_GameControllerExtendedBind::axis
int axis
Definition: controllermap.c:122
SDL_CONTROLLER_BINDTYPE_HAT
Definition: SDL_gamecontroller.h:66
SDL_GameControllerExtendedBind::button
int button
Definition: controllermap.c:119
SDL_CONTROLLER_BINDTYPE_AXIS
Definition: SDL_gamecontroller.h:65
SDL_arraysize
#define SDL_arraysize(array)
Definition: SDL_stdinc.h:93
s_arrBindings
static SDL_GameControllerExtendedBind s_arrBindings[BINDING_COUNT]
Definition: controllermap.c:138
SDL_CONTROLLER_BUTTON_DPAD_LEFT
Definition: SDL_gamecontroller.h:317
SDL_CONTROLLER_BINDTYPE_NONE
Definition: SDL_gamecontroller.h:63
SDL_CONTROLLER_BUTTON_DPAD_DOWN
Definition: SDL_gamecontroller.h:316

## LoadTexture()

SDL_Texture* LoadTexture | ( | SDL_Renderer * | renderer,
|  | const char * | file,
|  | SDL_bool | transparent
| ) |  |

Definition at line 155 of file controllermap.c.

References SDL_Surface::format, NULL, SDL_PixelFormat::palette, SDL_Surface::pixels, SDL_CreateTextureFromSurface, SDL_FreeSurface, SDL_GetError, SDL_LoadBMP, SDL_LOG_CATEGORY_APPLICATION, SDL_LogError, SDL_SetColorKey, and SDL_TRUE.

Referenced by WatchJoystick().

{
SDL_Surface *temp;
SDL_Texture *texture;
/* Load the sprite image */
temp = SDL_LoadBMP(file);
if (temp == NULL) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Couldn't load %s: %s", file, SDL_GetError());
return NULL;
}
/* Set transparent pixel as the pixel at (0,0) */
if (transparent) {
if (temp->format->palette) {
SDL_SetColorKey(temp, SDL_TRUE, *(Uint8 *) temp->pixels);
}
}
/* Create textures from the image */
texture = SDL_CreateTextureFromSurface(renderer, temp);
if (!texture) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Couldn't create texture: %s\n", SDL_GetError());
SDL_FreeSurface(temp);
return NULL;
}
SDL_FreeSurface(temp);
/* We're ready to roll. :) */
return texture;
}
SDL_GetError
#define SDL_GetError
Definition: SDL_dynapi_overrides.h:113
SDL_TRUE
Definition: SDL_stdinc.h:142
SDL_LoadBMP
#define SDL_LoadBMP(file)
Definition: SDL_surface.h:200
SDL_Surface
A collection of pixels used in software blitting.
Definition: SDL_surface.h:69
SDL_Texture
Definition: SDL_sysrender.h:49
SDL_LogError
#define SDL_LogError
Definition: SDL_dynapi_overrides.h:36
texture
GLenum GLenum GLuint texture
Definition: SDL_opengl_glext.h:1178
SDL_CreateTextureFromSurface
#define SDL_CreateTextureFromSurface
Definition: SDL_dynapi_overrides.h:307
SDL_Surface::pixels
void * pixels
Definition: SDL_surface.h:75
SDL_FreeSurface
#define SDL_FreeSurface
Definition: SDL_dynapi_overrides.h:446
Uint8
uint8_t Uint8
Definition: SDL_stdinc.h:157
SDL_SetColorKey
#define SDL_SetColorKey
Definition: SDL_dynapi_overrides.h:453
NULL
#define NULL
Definition: begin_code.h:164
SDL_Surface::format
SDL_PixelFormat * format
Definition: SDL_surface.h:72
SDL_PixelFormat::palette
SDL_Palette * palette
Definition: SDL_pixels.h:318
SDL_LOG_CATEGORY_APPLICATION
Definition: SDL_log.h:66

## main()

int main | ( | int | argc,
|  | char * | argv[]
| ) |  |

Definition at line 704 of file controllermap.c.

References device, i, NULL, SDL_GetError, SDL_Init, SDL_INIT_JOYSTICK, SDL_INIT_VIDEO, SDL_JoystickClose, SDL_JoystickGetGUID, SDL_JoystickGetGUIDString, SDL_JoystickGetProduct, SDL_JoystickGetVendor, SDL_JoystickInstanceID, SDL_JoystickNameForIndex, SDL_JoystickNumAxes, SDL_JoystickNumBalls, SDL_JoystickNumButtons, SDL_JoystickNumHats, SDL_JoystickOpen, SDL_Log, SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_INFO, SDL_LogError, SDL_LogSetPriority, SDL_NumJoysticks, SDL_QuitSubSystem, and WatchJoystick().

{
const char *name;
int i;
SDL_Joystick *joystick;
/* Enable standard application logging */
SDL_LogSetPriority(SDL_LOG_CATEGORY_APPLICATION, SDL_LOG_PRIORITY_INFO);
/* Initialize SDL (Note: video is required to start event loop) */
if (SDL_Init(SDL_INIT_VIDEO | SDL_INIT_JOYSTICK) < 0) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Couldn't initialize SDL: %s\n", SDL_GetError());
exit(1);
}
/* Print information about the joysticks */
SDL_Log("There are %d joysticks attached\n", SDL_NumJoysticks());
for (i = 0; i < SDL_NumJoysticks(); ++i) {
name = SDL_JoystickNameForIndex(i);
SDL_Log("Joystick %d: %s\n", i, name ? name : "Unknown Joystick");
joystick = SDL_JoystickOpen(i);
if (joystick == NULL) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "SDL_JoystickOpen(%d) failed: %s\n", i,
SDL_GetError());
} else {
char guid[64];
SDL_JoystickGetGUIDString(SDL_JoystickGetGUID(joystick),
guid, sizeof (guid));
SDL_Log(" axes: %d\n", SDL_JoystickNumAxes(joystick));
SDL_Log(" balls: %d\n", SDL_JoystickNumBalls(joystick));
SDL_Log(" hats: %d\n", SDL_JoystickNumHats(joystick));
SDL_Log(" buttons: %d\n", SDL_JoystickNumButtons(joystick));
SDL_Log("instance id: %d\n", SDL_JoystickInstanceID(joystick));
SDL_Log(" guid: %s\n", guid);
SDL_Log(" VID/PID: 0x%.4x/0x%.4x\n", SDL_JoystickGetVendor(joystick), SDL_JoystickGetProduct(joystick));
SDL_JoystickClose(joystick);
}
}
#ifdef __ANDROID__
if (SDL_NumJoysticks() > 0) {
#else
if (argv[1]) {
#endif
int device;
#ifdef __ANDROID__
device = 0;
#else
device = atoi(argv[1]);
#endif
joystick = SDL_JoystickOpen(device);
if (joystick == NULL) {
SDL_Log("Couldn't open joystick %d: %s\n", device, SDL_GetError());
} else {
WatchJoystick(joystick);
SDL_JoystickClose(joystick);
}
}
else {
SDL_Log("\n\nUsage: ./controllermap number\nFor example: ./controllermap 0\nOr: ./controllermap 0 >> gamecontrollerdb.txt");
}
SDL_QuitSubSystem(SDL_INIT_VIDEO | SDL_INIT_JOYSTICK);
return 0;
}
SDL_GetError
#define SDL_GetError
Definition: SDL_dynapi_overrides.h:113
SDL_JoystickClose
#define SDL_JoystickClose
Definition: SDL_dynapi_overrides.h:215
SDL_JoystickGetVendor
#define SDL_JoystickGetVendor
Definition: SDL_dynapi_overrides.h:612
SDL_JoystickGetGUID
#define SDL_JoystickGetGUID
Definition: SDL_dynapi_overrides.h:200
SDL_INIT_JOYSTICK
#define SDL_INIT_JOYSTICK
Definition: SDL.h:79
SDL_QuitSubSystem
#define SDL_QuitSubSystem
Definition: SDL_dynapi_overrides.h:56
SDL_JoystickNameForIndex
#define SDL_JoystickNameForIndex
Definition: SDL_dynapi_overrides.h:196
SDL_JoystickOpen
#define SDL_JoystickOpen
Definition: SDL_dynapi_overrides.h:197
SDL_NumJoysticks
#define SDL_NumJoysticks
Definition: SDL_dynapi_overrides.h:195
SDL_JoystickNumButtons
#define SDL_JoystickNumButtons
Definition: SDL_dynapi_overrides.h:208
SDL_JoystickGetGUIDString
#define SDL_JoystickGetGUIDString
Definition: SDL_dynapi_overrides.h:201
SDL_JoystickInstanceID
#define SDL_JoystickInstanceID
Definition: SDL_dynapi_overrides.h:204
SDL_JoystickGetProduct
#define SDL_JoystickGetProduct
Definition: SDL_dynapi_overrides.h:613
name
GLuint const GLchar * name
Definition: SDL_opengl_glext.h:660
SDL_LogError
#define SDL_LogError
Definition: SDL_dynapi_overrides.h:36
SDL_JoystickNumAxes
#define SDL_JoystickNumAxes
Definition: SDL_dynapi_overrides.h:205
device
static SDL_AudioDeviceID device
Definition: loopwave.c:37
SDL_Log
#define SDL_Log
Definition: SDL_dynapi_overrides.h:31
WatchJoystick
static void WatchJoystick(SDL_Joystick *joystick)
Definition: controllermap.c:354
SDL_LOG_PRIORITY_INFO
Definition: SDL_log.h:106
i
return Display return Display Bool Bool int int int return Display XEvent Bool(*) XPointer return Display return Display Drawable _Xconst char unsigned int unsigned int return Display Pixmap Pixmap XColor XColor unsigned int unsigned int return Display _Xconst char char int char return Display Visual unsigned int int int char unsigned int unsigned int in i)
Definition: SDL_x11sym.h:50
SDL_LogSetPriority
#define SDL_LogSetPriority
Definition: SDL_dynapi_overrides.h:236
NULL
#define NULL
Definition: begin_code.h:164
SDL_JoystickNumHats
#define SDL_JoystickNumHats
Definition: SDL_dynapi_overrides.h:207
SDL_JoystickNumBalls
#define SDL_JoystickNumBalls
Definition: SDL_dynapi_overrides.h:206
SDL_Init
#define SDL_Init
Definition: SDL_dynapi_overrides.h:54
SDL_LOG_CATEGORY_APPLICATION
Definition: SDL_log.h:66
SDL_INIT_VIDEO
#define SDL_INIT_VIDEO
Definition: SDL.h:78

## SetCurrentBinding()

static void SetCurrentBinding | ( | int | iBinding | ) |

static

Definition at line 200 of file controllermap.c.

References BINDING_COUNT, AxisState::m_nFarthestValue, AxisState::m_nStartingValue, s_arrBindingOrder, s_bBindingComplete, s_iCurrentBinding, s_nNumAxes, s_unPendingAdvanceTime, SDL_TRUE, and SDL_zerop.

Referenced by ConfigureBinding(), and WatchJoystick().

{
int iIndex;
SDL_GameControllerExtendedBind *pBinding;
if (iBinding < 0) {
return;
}
if (iBinding == BINDING_COUNT) {
s_bBindingComplete = SDL_TRUE;
return;
}
s_iCurrentBinding = iBinding;
pBinding = &s_arrBindings[s_arrBindingOrder[s_iCurrentBinding]];
SDL_zerop(pBinding);
for (iIndex = 0; iIndex < s_nNumAxes; ++iIndex) {
s_arrAxisState[iIndex].m_nFarthestValue = s_arrAxisState[iIndex].m_nStartingValue;
}
s_unPendingAdvanceTime = 0;
}
s_bBindingComplete
static SDL_bool s_bBindingComplete
Definition: controllermap.c:152
BINDING_COUNT
#define BINDING_COUNT
Definition: controllermap.c:50
s_arrAxisState
static AxisState * s_arrAxisState
Definition: controllermap.c:148
SDL_TRUE
Definition: SDL_stdinc.h:142
SDL_GameControllerExtendedBind
Definition: controllermap.c:114
s_arrBindingOrder
static int s_arrBindingOrder[BINDING_COUNT]
Definition: controllermap.c:86
AxisState::m_nFarthestValue
int m_nFarthestValue
Definition: controllermap.c:144
SDL_zerop
#define SDL_zerop(x)
Definition: SDL_stdinc.h:417
s_unPendingAdvanceTime
static Uint32 s_unPendingAdvanceTime
Definition: controllermap.c:151
s_iCurrentBinding
static int s_iCurrentBinding
Definition: controllermap.c:150
AxisState::m_nStartingValue
int m_nStartingValue
Definition: controllermap.c:143
s_nNumAxes
static int s_nNumAxes
Definition: controllermap.c:147
s_arrBindings
static SDL_GameControllerExtendedBind s_arrBindings[BINDING_COUNT]
Definition: controllermap.c:138

## StandardizeAxisValue()

static int StandardizeAxisValue | ( | int | nValue | ) |

static

Definition at line 188 of file controllermap.c.

References SDL_JOYSTICK_AXIS_MAX, and SDL_JOYSTICK_AXIS_MIN.

Referenced by WatchJoystick().

{
if (nValue > SDL_JOYSTICK_AXIS_MAX/2) {
return SDL_JOYSTICK_AXIS_MAX;
} else if (nValue < SDL_JOYSTICK_AXIS_MIN/2) {
return SDL_JOYSTICK_AXIS_MIN;
} else {
return 0;
}
}
SDL_JOYSTICK_AXIS_MIN
#define SDL_JOYSTICK_AXIS_MIN
Definition: SDL_joystick.h:289
SDL_JOYSTICK_AXIS_MAX
#define SDL_JOYSTICK_AXIS_MAX
Definition: SDL_joystick.h:288

## WatchJoystick()

static void WatchJoystick | ( | SDL_Joystick * | joystick | ) |

static

Definition at line 354 of file controllermap.c.

References axis, SDL_GameControllerExtendedBind::axis, SDL_JoyAxisEvent::axis, background, SDL_GameControllerExtendedBind::bindType, BMergeAxisBindings(), button, SDL_GameControllerExtendedBind::button, SDL_JoyButtonEvent::button, SDL_GameControllerExtendedBind::committed, ConfigureBinding(), done, SDL_Rect::h, SDL_GameControllerExtendedBind::hat, SDL_JoyHatEvent::hat, SDL_Event::jaxis, SDL_Event::jbutton, SDL_Event::jhat, SDL_Event::key, SDL_KeyboardEvent::keysym, LoadTexture(), AxisState::m_bMoving, AxisState::m_nFarthestValue, AxisState::m_nStartingValue, marker, MARKER_AXIS, MARKER_BUTTON, NULL, s_arrBindingDisplay, s_arrBindingOrder, s_bBindingComplete, s_iCurrentBinding, s_nNumAxes, s_unPendingAdvanceTime, screen, SCREEN_HEIGHT, SCREEN_WIDTH, SDL_abs, SDL_ALPHA_OPAQUE, SDL_arraysize, SDL_assert, SDL_calloc, SDL_CONTROLLER_AXIS_LEFTX, SDL_CONTROLLER_AXIS_LEFTY, SDL_CONTROLLER_AXIS_RIGHTX, SDL_CONTROLLER_AXIS_RIGHTY, SDL_CONTROLLER_AXIS_TRIGGERLEFT, SDL_CONTROLLER_AXIS_TRIGGERRIGHT, SDL_CONTROLLER_BINDING_AXIS_LEFTX_NEGATIVE, SDL_CONTROLLER_BINDING_AXIS_LEFTX_POSITIVE, SDL_CONTROLLER_BINDING_AXIS_LEFTY_NEGATIVE, SDL_CONTROLLER_BINDING_AXIS_LEFTY_POSITIVE, SDL_CONTROLLER_BINDING_AXIS_RIGHTX_NEGATIVE, SDL_CONTROLLER_BINDING_AXIS_RIGHTX_POSITIVE, SDL_CONTROLLER_BINDING_AXIS_RIGHTY_NEGATIVE, SDL_CONTROLLER_BINDING_AXIS_RIGHTY_POSITIVE, SDL_CONTROLLER_BINDING_AXIS_TRIGGERLEFT, SDL_CONTROLLER_BINDING_AXIS_TRIGGERRIGHT, SDL_CONTROLLER_BINDTYPE_AXIS, SDL_CONTROLLER_BINDTYPE_BUTTON, SDL_CONTROLLER_BINDTYPE_HAT, SDL_CONTROLLER_BINDTYPE_NONE, SDL_CONTROLLER_BUTTON_MAX, SDL_CreateRenderer, SDL_CreateWindow, SDL_Delay, SDL_DestroyRenderer, SDL_DestroyWindow, SDL_FALSE, SDL_FINGERDOWN, SDL_FLIP_NONE, SDL_free, SDL_GameControllerGetStringForAxis, SDL_GameControllerGetStringForButton, SDL_GetError, SDL_GetPlatform, SDL_GetTicks(), SDL_HAT_CENTERED, SDL_isspace, SDL_JOYAXISMOTION, SDL_JOYBALLMOTION, SDL_JOYBUTTONDOWN, SDL_JOYDEVICEREMOVED, SDL_JOYHATMOTION, SDL_JOYSTICK_AXIS_MAX, SDL_JOYSTICK_AXIS_MIN, SDL_JoystickGetAxisInitialState, SDL_JoystickGetGUID, SDL_JoystickGetGUIDString, SDL_JoystickInstanceID, SDL_JoystickName, SDL_JoystickNumAxes, SDL_JoystickNumBalls, SDL_JoystickNumButtons, SDL_JoystickNumHats, SDL_KEYDOWN, SDL_Log, SDL_LOG_CATEGORY_APPLICATION, SDL_LogError, SDL_memmove, SDL_MOUSEBUTTONDOWN, SDL_PollEvent, SDL_QueryTexture, SDL_QUIT, SDL_RaiseWindow, SDL_RenderClear, SDL_RenderCopy, SDL_RenderCopyEx, SDL_RenderPresent, SDL_RenderSetLogicalSize, SDL_SetRenderDrawColor, SDL_SetTextureAlphaMod, SDL_SetTextureColorMod, SDL_snprintf, SDL_strchr, SDL_strlcat, SDL_strlcpy, SDL_strlen, SDL_TRUE, SDL_WINDOWPOS_CENTERED, SDL_zero, SDLK_AC_BACK, SDLK_BACKSPACE, SDLK_ESCAPE, SDLK_SPACE, SetCurrentBinding(), StandardizeAxisValue(), SDL_Keysym::sym, SDL_Event::type, SDL_GameControllerExtendedBind::value, SDL_JoyHatEvent::value, SDL_Rect::w, SDL_JoyAxisEvent::which, SDL_JoyHatEvent::which, SDL_JoyButtonEvent::which, SDL_Rect::x, and SDL_Rect::y.

Referenced by main().

{
SDL_Window *window = NULL;
SDL_Renderer *screen = NULL;
SDL_Texture *background, *button, *axis, *marker;
const char *name = NULL;
SDL_bool done = SDL_FALSE;
SDL_Event event;
SDL_Rect dst;
Uint8 alpha=200, alpha_step = -1;
Uint32 alpha_ticks = 0;
SDL_JoystickID nJoystickID;
int iIndex;
/* Create a window to display joystick axis position */
window = SDL_CreateWindow("Game Controller Map", SDL_WINDOWPOS_CENTERED,
SDL_WINDOWPOS_CENTERED, SCREEN_WIDTH,
SCREEN_HEIGHT, 0);
if (window == NULL) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Couldn't create window: %s\n", SDL_GetError());
return;
}
screen = SDL_CreateRenderer(window, -1, 0);
if (screen == NULL) {
SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Couldn't create renderer: %s\n", SDL_GetError());
SDL_DestroyWindow(window);
return;
}
background = LoadTexture(screen, "controllermap.bmp", SDL_FALSE);
button = LoadTexture(screen, "button.bmp", SDL_TRUE);
axis = LoadTexture(screen, "axis.bmp", SDL_TRUE);
SDL_RaiseWindow(window);
/* scale for platforms that don't give you the window size you asked for. */
SDL_RenderSetLogicalSize(screen, SCREEN_WIDTH, SCREEN_HEIGHT);
/* Print info about the joystick we are watching */
name = SDL_JoystickName(joystick);
SDL_Log("Watching joystick %d: (%s)\n", SDL_JoystickInstanceID(joystick),
name ? name : "Unknown Joystick");
SDL_Log("Joystick has %d axes, %d hats, %d balls, and %d buttons\n",
SDL_JoystickNumAxes(joystick), SDL_JoystickNumHats(joystick),
SDL_JoystickNumBalls(joystick), SDL_JoystickNumButtons(joystick));
SDL_Log("\n\n\
====================================================================================\n\
Press the buttons on your controller when indicated\n\
(Your controller may look different than the picture)\n\
If you want to correct a mistake, press backspace or the back button on your device\n\
To skip a button, press SPACE or click/touch the screen\n\
To exit, press ESC\n\
====================================================================================\n");
nJoystickID = SDL_JoystickInstanceID(joystick);
s_nNumAxes = SDL_JoystickNumAxes(joystick);
s_arrAxisState = (AxisState *)SDL_calloc(s_nNumAxes, sizeof(*s_arrAxisState));
for (iIndex = 0; iIndex < s_nNumAxes; ++iIndex) {
AxisState *pAxisState = &s_arrAxisState[iIndex];
Sint16 nInitialValue;
pAxisState->m_bMoving = SDL_JoystickGetAxisInitialState(joystick, iIndex, &nInitialValue);
pAxisState->m_nStartingValue = nInitialValue;
pAxisState->m_nFarthestValue = nInitialValue;
}
/* Loop, getting joystick events! */
while (!done && !s_bBindingComplete) {
int iElement = s_arrBindingOrder[s_iCurrentBinding];
switch (s_arrBindingDisplay[iElement].marker) {
case MARKER_AXIS:
marker = axis;
break;
case MARKER_BUTTON:
marker = button;
break;
default:
break;
}
dst.x = s_arrBindingDisplay[iElement].x;
dst.y = s_arrBindingDisplay[iElement].y;
SDL_QueryTexture(marker, NULL, NULL, &dst.w, &dst.h);
if (SDL_GetTicks() - alpha_ticks > 5) {
alpha_ticks = SDL_GetTicks();
alpha += alpha_step;
if (alpha == 255) {
alpha_step = -1;
}
if (alpha < 128) {
alpha_step = 1;
}
}
SDL_SetRenderDrawColor(screen, 0xFF, 0xFF, 0xFF, SDL_ALPHA_OPAQUE);
SDL_RenderClear(screen);
SDL_RenderCopy(screen, background, NULL, NULL);
SDL_SetTextureAlphaMod(marker, alpha);
SDL_SetTextureColorMod(marker, 10, 255, 21);
SDL_RenderCopyEx(screen, marker, NULL, &dst, s_arrBindingDisplay[iElement].angle, NULL, SDL_FLIP_NONE);
SDL_RenderPresent(screen);
while (SDL_PollEvent(&event) > 0) {
switch (event.type) {
case SDL_JOYDEVICEREMOVED:
if (event.jaxis.which == nJoystickID) {
done = SDL_TRUE;
}
break;
case SDL_JOYAXISMOTION:
if (event.jaxis.which == nJoystickID) {
AxisState *pAxisState = &s_arrAxisState[event.jaxis.axis];
int nValue = event.jaxis.value;
int nCurrentDistance, nFarthestDistance;
if (!pAxisState->m_bMoving) {
pAxisState->m_bMoving = SDL_TRUE;
pAxisState->m_nStartingValue = nValue;
pAxisState->m_nFarthestValue = nValue;
}
nCurrentDistance = SDL_abs(nValue - pAxisState->m_nStartingValue);
nFarthestDistance = SDL_abs(pAxisState->m_nFarthestValue - pAxisState->m_nStartingValue);
if (nCurrentDistance > nFarthestDistance) {
pAxisState->m_nFarthestValue = nValue;
nFarthestDistance = SDL_abs(pAxisState->m_nFarthestValue - pAxisState->m_nStartingValue);
}
#ifdef DEBUG_CONTROLLERMAP
SDL_Log("AXIS %d nValue %d nCurrentDistance %d nFarthestDistance %d\n", event.jaxis.axis, nValue, nCurrentDistance, nFarthestDistance);
#endif
if (nFarthestDistance >= 16000) {
/* If we've gone out far enough and started to come back, let's bind this axis */
SDL_bool bCommitBinding = (nCurrentDistance <= 10000) ? SDL_TRUE : SDL_FALSE;
SDL_GameControllerExtendedBind binding;
SDL_zero(binding);
binding.bindType = SDL_CONTROLLER_BINDTYPE_AXIS;
binding.value.axis.axis = event.jaxis.axis;
binding.value.axis.axis_min = StandardizeAxisValue(pAxisState->m_nStartingValue);
binding.value.axis.axis_max = StandardizeAxisValue(pAxisState->m_nFarthestValue);
binding.committed = bCommitBinding;
ConfigureBinding(&binding);
}
}
break;
case SDL_JOYHATMOTION:
if (event.jhat.which == nJoystickID) {
if (event.jhat.value != SDL_HAT_CENTERED) {
SDL_GameControllerExtendedBind binding;
#ifdef DEBUG_CONTROLLERMAP
SDL_Log("HAT %d %d\n", event.jhat.hat, event.jhat.value);
#endif
SDL_zero(binding);
binding.bindType = SDL_CONTROLLER_BINDTYPE_HAT;
binding.value.hat.hat = event.jhat.hat;
binding.value.hat.hat_mask = event.jhat.value;
binding.committed = SDL_TRUE;
ConfigureBinding(&binding);
}
}
break;
case SDL_JOYBALLMOTION:
break;
case SDL_JOYBUTTONDOWN:
if (event.jbutton.which == nJoystickID) {
SDL_GameControllerExtendedBind binding;
#ifdef DEBUG_CONTROLLERMAP
SDL_Log("BUTTON %d\n", event.jbutton.button);
#endif
SDL_zero(binding);
binding.bindType = SDL_CONTROLLER_BINDTYPE_BUTTON;
binding.value.button = event.jbutton.button;
binding.committed = SDL_TRUE;
ConfigureBinding(&binding);
}
break;
case SDL_FINGERDOWN:
case SDL_MOUSEBUTTONDOWN:
/* Skip this step */
SetCurrentBinding(s_iCurrentBinding + 1);
break;
case SDL_KEYDOWN:
if (event.key.keysym.sym == SDLK_BACKSPACE || event.key.keysym.sym == SDLK_AC_BACK) {
SetCurrentBinding(s_iCurrentBinding - 1);
break;
}
if (event.key.keysym.sym == SDLK_SPACE) {
SetCurrentBinding(s_iCurrentBinding + 1);
break;
}
if ((event.key.keysym.sym != SDLK_ESCAPE)) {
break;
}
/* Fall through to signal quit */
case SDL_QUIT:
done = SDL_TRUE;
break;
default:
break;
}
}
SDL_Delay(15);
/* Wait 100 ms for joystick events to stop coming in,
in case a controller sends multiple events for a single control (e.g. axis and button for trigger)
*/
if (s_unPendingAdvanceTime && SDL_GetTicks() - s_unPendingAdvanceTime >= 100) {
SetCurrentBinding(s_iCurrentBinding + 1);
}
}
if (s_bBindingComplete) {
char mapping[1024];
char trimmed_name[128];
char *spot;
int iIndex;
char pszElement[12];
SDL_strlcpy(trimmed_name, name, SDL_arraysize(trimmed_name));
while (SDL_isspace(trimmed_name[0])) {
SDL_memmove(&trimmed_name[0], &trimmed_name[1], SDL_strlen(trimmed_name));
}
while (trimmed_name[0] && SDL_isspace(trimmed_name[SDL_strlen(trimmed_name) - 1])) {
trimmed_name[SDL_strlen(trimmed_name) - 1] = '\0';
}
while ((spot = SDL_strchr(trimmed_name, ',')) != NULL) {
SDL_memmove(spot, spot + 1, SDL_strlen(spot));
}
/* Initialize mapping with GUID and name */
SDL_JoystickGetGUIDString(SDL_JoystickGetGUID(joystick), mapping, SDL_arraysize(mapping));
SDL_strlcat(mapping, ",", SDL_arraysize(mapping));
SDL_strlcat(mapping, trimmed_name, SDL_arraysize(mapping));
SDL_strlcat(mapping, ",", SDL_arraysize(mapping));
SDL_strlcat(mapping, "platform:", SDL_arraysize(mapping));
SDL_strlcat(mapping, SDL_GetPlatform(), SDL_arraysize(mapping));
SDL_strlcat(mapping, ",", SDL_arraysize(mapping));
for (iIndex = 0; iIndex < SDL_arraysize(s_arrBindings); ++iIndex) {
SDL_GameControllerExtendedBind *pBinding = &s_arrBindings[iIndex];
if (pBinding->bindType == SDL_CONTROLLER_BINDTYPE_NONE) {
continue;
}
if (iIndex < SDL_CONTROLLER_BUTTON_MAX) {
SDL_GameControllerButton eButton = (SDL_GameControllerButton)iIndex;
SDL_strlcat(mapping, SDL_GameControllerGetStringForButton(eButton), SDL_arraysize(mapping));
} else {
const char *pszAxisName;
switch (iIndex - SDL_CONTROLLER_BUTTON_MAX) {
case SDL_CONTROLLER_BINDING_AXIS_LEFTX_NEGATIVE:
if (!BMergeAxisBindings(iIndex)) {
SDL_strlcat(mapping, "-", SDL_arraysize(mapping));
}
pszAxisName = SDL_GameControllerGetStringForAxis(SDL_CONTROLLER_AXIS_LEFTX);
break;
case SDL_CONTROLLER_BINDING_AXIS_LEFTX_POSITIVE:
SDL_strlcat(mapping, "+", SDL_arraysize(mapping));
pszAxisName = SDL_GameControllerGetStringForAxis(SDL_CONTROLLER_AXIS_LEFTX);
break;
case SDL_CONTROLLER_BINDING_AXIS_LEFTY_NEGATIVE:
if (!BMergeAxisBindings(iIndex)) {
SDL_strlcat(mapping, "-", SDL_arraysize(mapping));
}
pszAxisName = SDL_GameControllerGetStringForAxis(SDL_CONTROLLER_AXIS_LEFTY);
break;
case SDL_CONTROLLER_BINDING_AXIS_LEFTY_POSITIVE:
SDL_strlcat(mapping, "+", SDL_arraysize(mapping));
pszAxisName = SDL_GameControllerGetStringForAxis(SDL_CONTROLLER_AXIS_LEFTY);
break;
case SDL_CONTROLLER_BINDING_AXIS_RIGHTX_NEGATIVE:
if (!BMergeAxisBindings(iIndex)) {
SDL_strlcat(mapping, "-", SDL_arraysize(mapping));
}
pszAxisName = SDL_GameControllerGetStringForAxis(SDL_CONTROLLER_AXIS_RIGHTX);
break;
case SDL_CONTROLLER_BINDING_AXIS_RIGHTX_POSITIVE:
SDL_strlcat(mapping, "+", SDL_arraysize(mapping));
pszAxisName = SDL_GameControllerGetStringForAxis(SDL_CONTROLLER_AXIS_RIGHTX);
break;
case SDL_CONTROLLER_BINDING_AXIS_RIGHTY_NEGATIVE:
if (!BMergeAxisBindings(iIndex)) {
SDL_strlcat(mapping, "-", SDL_arraysize(mapping));
}
pszAxisName = SDL_GameControllerGetStringForAxis(SDL_CONTROLLER_AXIS_RIGHTY);
break;
case SDL_CONTROLLER_BINDING_AXIS_RIGHTY_POSITIVE:
SDL_strlcat(mapping, "+", SDL_arraysize(mapping));
pszAxisName = SDL_GameControllerGetStringForAxis(SDL_CONTROLLER_AXIS_RIGHTY);
break;
case SDL_CONTROLLER_BINDING_AXIS_TRIGGERLEFT:
pszAxisName = SDL_GameControllerGetStringForAxis(SDL_CONTROLLER_AXIS_TRIGGERLEFT);
break;
case SDL_CONTROLLER_BINDING_AXIS_TRIGGERRIGHT:
pszAxisName = SDL_GameControllerGetStringForAxis(SDL_CONTROLLER_AXIS_TRIGGERRIGHT);
break;
}
SDL_strlcat(mapping, pszAxisName, SDL_arraysize(mapping));
}
SDL_strlcat(mapping, ":", SDL_arraysize(mapping));
pszElement[0] = '\0';
switch (pBinding->bindType) {
case SDL_CONTROLLER_BINDTYPE_BUTTON:
SDL_snprintf(pszElement, sizeof(pszElement), "b%d", pBinding->value.button);
break;
case SDL_CONTROLLER_BINDTYPE_AXIS:
if (pBinding->value.axis.axis_min == 0 && pBinding->value.axis.axis_max == SDL_JOYSTICK_AXIS_MIN) {
/* The negative half axis */
SDL_snprintf(pszElement, sizeof(pszElement), "-a%d", pBinding->value.axis.axis);
} else if (pBinding->value.axis.axis_min == 0 && pBinding->value.axis.axis_max == SDL_JOYSTICK_AXIS_MAX) {
/* The positive half axis */
SDL_snprintf(pszElement, sizeof(pszElement), "+a%d", pBinding->value.axis.axis);
} else {
SDL_snprintf(pszElement, sizeof(pszElement), "a%d", pBinding->value.axis.axis);
if (pBinding->value.axis.axis_min > pBinding->value.axis.axis_max) {
/* Invert the axis */
SDL_strlcat(pszElement, "~", SDL_arraysize(pszElement));
}
}
break;
case SDL_CONTROLLER_BINDTYPE_HAT:
SDL_snprintf(pszElement, sizeof(pszElement), "h%d.%d", pBinding->value.hat.hat, pBinding->value.hat.hat_mask);
break;
default:
SDL_assert(!"Unknown bind type");
break;
}
SDL_strlcat(mapping, pszElement, SDL_arraysize(mapping));
SDL_strlcat(mapping, ",", SDL_arraysize(mapping));
}
SDL_Log("Mapping:\n\n%s\n\n", mapping);
/* Print to stdout as well so the user can cat the output somewhere */
printf("%s\n", mapping);
}
SDL_free(s_arrAxisState);
s_arrAxisState = NULL;
SDL_DestroyRenderer(screen);
SDL_DestroyWindow(window);
}
SDL_CONTROLLER_AXIS_LEFTY
Definition: SDL_gamecontroller.h:261
SDL_CONTROLLER_BINDING_AXIS_RIGHTY_POSITIVE
Definition: controllermap.c:44
SDL_CONTROLLER_AXIS_RIGHTY
Definition: SDL_gamecontroller.h:263
ConfigureBinding
static void ConfigureBinding(const SDL_GameControllerExtendedBind *pBinding)
Definition: controllermap.c:256
SDL_strlcpy
#define SDL_strlcpy
Definition: SDL_dynapi_overrides.h:394
SDL_abs
#define SDL_abs
Definition: SDL_dynapi_overrides.h:381
SDL_JoyButtonEvent::which
SDL_JoystickID which
Definition: SDL_events.h:335
StandardizeAxisValue
static int StandardizeAxisValue(int nValue)
Definition: controllermap.c:188
SCREEN_HEIGHT
#define SCREEN_HEIGHT
Definition: controllermap.c:29
SDL_JOYHATMOTION
Definition: SDL_events.h:110
s_bBindingComplete
static SDL_bool s_bBindingComplete
Definition: controllermap.c:152
SDL_WINDOWPOS_CENTERED
#define SDL_WINDOWPOS_CENTERED
Definition: SDL_video.h:139
SDL_PollEvent
#define SDL_PollEvent
Definition: SDL_dynapi_overrides.h:122
SetCurrentBinding
static void SetCurrentBinding(int iBinding)
Definition: controllermap.c:200
SDL_KEYDOWN
Definition: SDL_events.h:93
SDL_GetError
#define SDL_GetError
Definition: SDL_dynapi_overrides.h:113
SDLK_BACKSPACE
Definition: SDL_keycode.h:56
SDL_JoyAxisEvent::axis
Uint8 axis
Definition: SDL_events.h:284
button
SDL_Texture * button
Definition: testgamecontroller.c:67
s_arrAxisState
static AxisState * s_arrAxisState
Definition: controllermap.c:148
SDL_TRUE
Definition: SDL_stdinc.h:142
SDL_strlcat
#define SDL_strlcat
Definition: SDL_dynapi_overrides.h:396
SCREEN_WIDTH
#define SCREEN_WIDTH
Definition: controllermap.c:28
SDL_JoystickGetGUID
#define SDL_JoystickGetGUID
Definition: SDL_dynapi_overrides.h:200
dst
GLenum GLenum dst
Definition: SDL_opengl_glext.h:1737
SDL_Event::jbutton
SDL_JoyButtonEvent jbutton
Definition: SDL_events.h:539
SDL_GameControllerExtendedBind::value
union SDL_GameControllerExtendedBind::@48 value
SDL_CONTROLLER_BINDING_AXIS_TRIGGERRIGHT
Definition: controllermap.c:46
SDL_FLIP_NONE
Definition: SDL_render.h:113
SDL_GameControllerGetStringForButton
#define SDL_GameControllerGetStringForButton
Definition: SDL_dynapi_overrides.h:151
LoadTexture
SDL_Texture * LoadTexture(SDL_Renderer *renderer, const char *file, SDL_bool transparent)
Definition: controllermap.c:155
SDL_FALSE
Definition: SDL_stdinc.h:141
AxisState
Definition: controllermap.c:140
SDL_GameControllerExtendedBind
Definition: controllermap.c:114
SDL_MOUSEBUTTONDOWN
Definition: SDL_events.h:103
SDL_QUIT
Definition: SDL_events.h:60
SDL_JoyAxisEvent::which
SDL_JoystickID which
Definition: SDL_events.h:283
SDL_Renderer
Definition: SDL_sysrender.h:76
MARKER_AXIS
#define MARKER_AXIS
Definition: controllermap.c:33
SDL_GameControllerExtendedBind::committed
SDL_bool committed
Definition: controllermap.c:134
s_arrBindingOrder
static int s_arrBindingOrder[BINDING_COUNT]
Definition: controllermap.c:86
SDL_CONTROLLER_BINDTYPE_BUTTON
Definition: SDL_gamecontroller.h:64
AxisState::m_nFarthestValue
int m_nFarthestValue
Definition: controllermap.c:144
marker
int marker
Definition: controllermap.c:56
SDL_JoystickNumButtons
#define SDL_JoystickNumButtons
Definition: SDL_dynapi_overrides.h:208
SDL_JOYBALLMOTION
Definition: SDL_events.h:109
SDL_CreateWindow
#define SDL_CreateWindow
Definition: SDL_dynapi_overrides.h:514
axis
SDL_Texture * axis
Definition: testgamecontroller.c:67
background
SDL_Texture * background
Definition: testgamecontroller.c:67
Uint32
uint32_t Uint32
Definition: SDL_stdinc.h:181
SDL_GameControllerButton
SDL_GameControllerButton
Definition: SDL_gamecontroller.h:301
SDL_JOYAXISMOTION
Definition: SDL_events.h:108
SDL_JoystickGetGUIDString
#define SDL_JoystickGetGUIDString
Definition: SDL_dynapi_overrides.h:201
SDL_JoystickInstanceID
#define SDL_JoystickInstanceID
Definition: SDL_dynapi_overrides.h:204
AxisState::m_bMoving
SDL_bool m_bMoving
Definition: controllermap.c:142
s_arrBindingDisplay
static struct @47 s_arrBindingDisplay[BINDING_COUNT]
SDL_CONTROLLER_BINDING_AXIS_LEFTX_NEGATIVE
Definition: controllermap.c:37
alpha
GLfloat GLfloat GLfloat alpha
Definition: SDL_opengl_glext.h:412
name
GLuint const GLchar * name
Definition: SDL_opengl_glext.h:660
SDL_Texture
Definition: SDL_sysrender.h:49
SDL_JoystickName
#define SDL_JoystickName
Definition: SDL_dynapi_overrides.h:198
SDL_strchr
#define SDL_strchr
Definition: SDL_dynapi_overrides.h:401
SDL_LogError
#define SDL_LogError
Definition: SDL_dynapi_overrides.h:36
SDL_JoystickNumAxes
#define SDL_JoystickNumAxes
Definition: SDL_dynapi_overrides.h:205
SDL_JOYDEVICEREMOVED
Definition: SDL_events.h:114
SDL_RenderCopy
#define SDL_RenderCopy
Definition: SDL_dynapi_overrides.h:343
SDL_JOYSTICK_AXIS_MIN
#define SDL_JOYSTICK_AXIS_MIN
Definition: SDL_joystick.h:289
SDL_CONTROLLER_BINDING_AXIS_TRIGGERLEFT
Definition: controllermap.c:45
SDL_Log
#define SDL_Log
Definition: SDL_dynapi_overrides.h:31
SDL_FINGERDOWN
Definition: SDL_events.h:125
SDL_CONTROLLER_BINDING_AXIS_LEFTY_NEGATIVE
Definition: controllermap.c:39
SDL_JOYSTICK_AXIS_MAX
#define SDL_JOYSTICK_AXIS_MAX
Definition: SDL_joystick.h:288
s_unPendingAdvanceTime
static Uint32 s_unPendingAdvanceTime
Definition: controllermap.c:151
SDL_CONTROLLER_BINDING_AXIS_LEFTX_POSITIVE
Definition: controllermap.c:38
BMergeAxisBindings
static SDL_bool BMergeAxisBindings(int iIndex)
Definition: controllermap.c:336
SDL_JoystickID
Sint32 SDL_JoystickID
Definition: SDL_joystick.h:81
SDL_GameControllerGetStringForAxis
#define SDL_GameControllerGetStringForAxis
Definition: SDL_dynapi_overrides.h:147
SDL_JoystickGetAxisInitialState
#define SDL_JoystickGetAxisInitialState
Definition: SDL_dynapi_overrides.h:621
SDL_JOYBUTTONDOWN
Definition: SDL_events.h:111
SDL_GetTicks
Uint32 SDL_GetTicks(void)
Get the number of milliseconds since the SDL library initialization.
SDL_Event::jaxis
SDL_JoyAxisEvent jaxis
Definition: SDL_events.h:536
Uint8
uint8_t Uint8
Definition: SDL_stdinc.h:157
SDL_free
#define SDL_free
Definition: SDL_dynapi_overrides.h:377
event
struct _cl_event * event
Definition: SDL_opengl_glext.h:2649
SDL_CONTROLLER_AXIS_LEFTX
Definition: SDL_gamecontroller.h:260
SDL_RenderSetLogicalSize
#define SDL_RenderSetLogicalSize
Definition: SDL_dynapi_overrides.h:322
SDL_RaiseWindow
#define SDL_RaiseWindow
Definition: SDL_dynapi_overrides.h:535
done
int done
Definition: checkkeys.c:28
SDL_QueryTexture
#define SDL_QueryTexture
Definition: SDL_dynapi_overrides.h:308
s_iCurrentBinding
static int s_iCurrentBinding
Definition: controllermap.c:150
SDL_GameControllerExtendedBind::bindType
SDL_GameControllerBindType bindType
Definition: controllermap.c:116
SDL_CONTROLLER_BUTTON_MAX
Definition: SDL_gamecontroller.h:319
SDL_zero
#define SDL_zero(x)
Definition: SDL_stdinc.h:416
SDL_GetPlatform
#define SDL_GetPlatform
Definition: SDL_dynapi_overrides.h:291
SDL_GameControllerExtendedBind::hat
int hat
Definition: controllermap.c:128
AxisState::m_nStartingValue
int m_nStartingValue
Definition: controllermap.c:143
SDL_SetTextureColorMod
#define SDL_SetTextureColorMod
Definition: SDL_dynapi_overrides.h:309
SDL_memmove
#define SDL_memmove
Definition: SDL_dynapi_overrides.h:388
SDL_Rect::x
int x
Definition: SDL_rect.h:66
SDL_KeyboardEvent::keysym
SDL_Keysym keysym
Definition: SDL_events.h:199
SDL_CONTROLLER_BINDING_AXIS_RIGHTX_POSITIVE
Definition: controllermap.c:42
SDL_isspace
#define SDL_isspace
Definition: SDL_dynapi_overrides.h:383
SDL_Rect::w
int w
Definition: SDL_rect.h:67
s_nNumAxes
static int s_nNumAxes
Definition: controllermap.c:147
SDL_CONTROLLER_BINDING_AXIS_RIGHTX_NEGATIVE
Definition: controllermap.c:41
SDL_Delay
#define SDL_Delay
Definition: SDL_dynapi_overrides.h:486
SDL_assert
#define SDL_assert(condition)
Definition: SDL_assert.h:169
SDL_CONTROLLER_AXIS_TRIGGERRIGHT
Definition: SDL_gamecontroller.h:265
SDL_CONTROLLER_AXIS_TRIGGERLEFT
Definition: SDL_gamecontroller.h:264
NULL
#define NULL
Definition: begin_code.h:164
SDL_bool
SDL_bool
Definition: SDL_stdinc.h:139
SDL_JoystickNumHats
#define SDL_JoystickNumHats
Definition: SDL_dynapi_overrides.h:207
SDL_CONTROLLER_BINDING_AXIS_RIGHTY_NEGATIVE
Definition: controllermap.c:43
SDL_calloc
#define SDL_calloc
Definition: SDL_dynapi_overrides.h:375
SDL_JoyHatEvent::hat
Uint8 hat
Definition: SDL_events.h:316
SDL_RenderClear
#define SDL_RenderClear
Definition: SDL_dynapi_overrides.h:334
window
EGLSurface EGLNativeWindowType * window
Definition: eglext.h:1025
SDL_Event::key
SDL_KeyboardEvent key
Definition: SDL_events.h:530
SDL_strlen
#define SDL_strlen
Definition: SDL_dynapi_overrides.h:393
SDL_Rect::h
int h
Definition: SDL_rect.h:67
SDL_Window
The type used to identify a window.
Definition: SDL_sysvideo.h:73
SDL_JoystickNumBalls
#define SDL_JoystickNumBalls
Definition: SDL_dynapi_overrides.h:206
SDL_JoyHatEvent::value
Uint8 value
Definition: SDL_events.h:317
SDL_CONTROLLER_AXIS_RIGHTX
Definition: SDL_gamecontroller.h:262
SDL_RenderCopyEx
#define SDL_RenderCopyEx
Definition: SDL_dynapi_overrides.h:344
SDL_Keysym::sym
SDL_Keycode sym
Definition: SDL_keyboard.h:50
SDL_GameControllerExtendedBind::axis
int axis
Definition: controllermap.c:122
angle
GLfloat angle
Definition: SDL_opengl_glext.h:6097
SDL_CONTROLLER_BINDTYPE_HAT
Definition: SDL_gamecontroller.h:66
SDL_GameControllerExtendedBind::button
int button
Definition: controllermap.c:119
SDL_snprintf
#define SDL_snprintf
Definition: SDL_dynapi_overrides.h:40
SDLK_AC_BACK
Definition: SDL_keycode.h:299
SDL_CONTROLLER_BINDTYPE_AXIS
Definition: SDL_gamecontroller.h:65
SDL_arraysize
#define SDL_arraysize(array)
Definition: SDL_stdinc.h:93
mapping
GLenum GLenum GLenum GLenum mapping
Definition: SDL_opengl_glext.h:9374
SDL_CONTROLLER_BINDING_AXIS_LEFTY_POSITIVE
Definition: controllermap.c:40
SDL_Event
General event structure.
Definition: SDL_events.h:525
s_arrBindings
static SDL_GameControllerExtendedBind s_arrBindings[BINDING_COUNT]
Definition: controllermap.c:138
SDL_SetRenderDrawColor
#define SDL_SetRenderDrawColor
Definition: SDL_dynapi_overrides.h:330
SDL_DestroyRenderer
#define SDL_DestroyRenderer
Definition: SDL_dynapi_overrides.h:348
SDL_Event::jhat
SDL_JoyHatEvent jhat
Definition: SDL_events.h:538
SDL_JoyButtonEvent::button
Uint8 button
Definition: SDL_events.h:336
SDL_HAT_CENTERED
#define SDL_HAT_CENTERED
Definition: SDL_joystick.h:316
SDLK_ESCAPE
Definition: SDL_keycode.h:55
SDL_ALPHA_OPAQUE
#define SDL_ALPHA_OPAQUE
Definition: SDL_pixels.h:46
screen
SDL_Renderer * screen
Definition: testgamecontroller.c:64
SDL_DestroyWindow
#define SDL_DestroyWindow
Definition: SDL_dynapi_overrides.h:549
SDL_LOG_CATEGORY_APPLICATION
Definition: SDL_log.h:66
MARKER_BUTTON
#define MARKER_BUTTON
Definition: controllermap.c:32
SDL_JoyHatEvent::which
SDL_JoystickID which
Definition: SDL_events.h:315
SDL_Rect::y
int y
Definition: SDL_rect.h:66
SDLK_SPACE
Definition: SDL_keycode.h:58
SDL_CreateRenderer
#define SDL_CreateRenderer
Definition: SDL_dynapi_overrides.h:301
SDL_Rect
A rectangle, with the origin at the upper left.
Definition: SDL_rect.h:64
SDL_CONTROLLER_BINDTYPE_NONE
Definition: SDL_gamecontroller.h:63
Sint16
int16_t Sint16
Definition: SDL_stdinc.h:163
SDL_RenderPresent
#define SDL_RenderPresent
Definition: SDL_dynapi_overrides.h:346
SDL_SetTextureAlphaMod
#define SDL_SetTextureAlphaMod
Definition: SDL_dynapi_overrides.h:311
SDL_Event::type
Uint32 type
Definition: SDL_events.h:527

## Variable Documentation

## angle

double angle

Definition at line 55 of file controllermap.c.

## marker

int marker

Definition at line 56 of file controllermap.c.

Referenced by WatchJoystick().

## s_arrAxisState

AxisState* s_arrAxisState

static

Definition at line 148 of file controllermap.c.

## s_arrBindingDisplay

struct { ... } s_arrBindingDisplay[BINDING_COUNT]

Initial value:
= {
{ 387, 167, 0.0, MARKER_BUTTON },
{ 431, 132, 0.0, MARKER_BUTTON },
{ 342, 132, 0.0, MARKER_BUTTON },
{ 389, 101, 0.0, MARKER_BUTTON },
{ 174, 132, 0.0, MARKER_BUTTON },
{ 233, 132, 0.0, MARKER_BUTTON },
{ 289, 132, 0.0, MARKER_BUTTON },
{ 75, 154, 0.0, MARKER_BUTTON },
{ 305, 230, 0.0, MARKER_BUTTON },
{ 77, 40, 0.0, MARKER_BUTTON },
{ 396, 36, 0.0, MARKER_BUTTON },
{ 154, 188, 0.0, MARKER_BUTTON },
{ 154, 249, 0.0, MARKER_BUTTON },
{ 116, 217, 0.0, MARKER_BUTTON },
{ 186, 217, 0.0, MARKER_BUTTON },
{ 74, 153, 270.0, MARKER_AXIS },
{ 74, 153, 90.0, MARKER_AXIS },
{ 74, 153, 0.0, MARKER_AXIS },
{ 74, 153, 180.0, MARKER_AXIS },
{ 306, 231, 270.0, MARKER_AXIS },
{ 306, 231, 90.0, MARKER_AXIS },
{ 306, 231, 0.0, MARKER_AXIS },
{ 306, 231, 180.0, MARKER_AXIS },
{ 91, -20, 180.0, MARKER_AXIS },
{ 375, -20, 180.0, MARKER_AXIS },
}
MARKER_AXIS
#define MARKER_AXIS
Definition: controllermap.c:33
MARKER_BUTTON
#define MARKER_BUTTON
Definition: controllermap.c:32

Referenced by WatchJoystick().

## s_arrBindingOrder

int s_arrBindingOrder[BINDING_COUNT]

static

Initial value:
= {
SDL_CONTROLLER_BUTTON_A,
SDL_CONTROLLER_BUTTON_B,
SDL_CONTROLLER_BUTTON_Y,
SDL_CONTROLLER_BUTTON_X,
SDL_CONTROLLER_BUTTON_MAX + SDL_CONTROLLER_BINDING_AXIS_LEFTX_NEGATIVE,
SDL_CONTROLLER_BUTTON_MAX + SDL_CONTROLLER_BINDING_AXIS_LEFTX_POSITIVE,
SDL_CONTROLLER_BUTTON_MAX + SDL_CONTROLLER_BINDING_AXIS_LEFTY_NEGATIVE,
SDL_CONTROLLER_BUTTON_MAX + SDL_CONTROLLER_BINDING_AXIS_LEFTY_POSITIVE,
SDL_CONTROLLER_BUTTON_LEFTSTICK,
SDL_CONTROLLER_BUTTON_MAX + SDL_CONTROLLER_BINDING_AXIS_RIGHTX_NEGATIVE,
SDL_CONTROLLER_BUTTON_MAX + SDL_CONTROLLER_BINDING_AXIS_RIGHTX_POSITIVE,
SDL_CONTROLLER_BUTTON_MAX + SDL_CONTROLLER_BINDING_AXIS_RIGHTY_NEGATIVE,
SDL_CONTROLLER_BUTTON_MAX + SDL_CONTROLLER_BINDING_AXIS_RIGHTY_POSITIVE,
SDL_CONTROLLER_BUTTON_RIGHTSTICK,
SDL_CONTROLLER_BUTTON_LEFTSHOULDER,
SDL_CONTROLLER_BUTTON_MAX + SDL_CONTROLLER_BINDING_AXIS_TRIGGERLEFT,
SDL_CONTROLLER_BUTTON_RIGHTSHOULDER,
SDL_CONTROLLER_BUTTON_MAX + SDL_CONTROLLER_BINDING_AXIS_TRIGGERRIGHT,
SDL_CONTROLLER_BUTTON_DPAD_UP,
SDL_CONTROLLER_BUTTON_DPAD_RIGHT,
SDL_CONTROLLER_BUTTON_DPAD_DOWN,
SDL_CONTROLLER_BUTTON_DPAD_LEFT,
SDL_CONTROLLER_BUTTON_BACK,
SDL_CONTROLLER_BUTTON_GUIDE,
SDL_CONTROLLER_BUTTON_START,
}
SDL_CONTROLLER_BINDING_AXIS_RIGHTY_POSITIVE
Definition: controllermap.c:44
SDL_CONTROLLER_BUTTON_BACK
Definition: SDL_gamecontroller.h:308
SDL_CONTROLLER_BUTTON_GUIDE
Definition: SDL_gamecontroller.h:309
SDL_CONTROLLER_BINDING_AXIS_TRIGGERRIGHT
Definition: controllermap.c:46
SDL_CONTROLLER_BUTTON_A
Definition: SDL_gamecontroller.h:304
SDL_CONTROLLER_BUTTON_DPAD_RIGHT
Definition: SDL_gamecontroller.h:318
SDL_CONTROLLER_BUTTON_B
Definition: SDL_gamecontroller.h:305
SDL_CONTROLLER_BINDING_AXIS_LEFTX_NEGATIVE
Definition: controllermap.c:37
SDL_CONTROLLER_BUTTON_START
Definition: SDL_gamecontroller.h:310
SDL_CONTROLLER_BUTTON_RIGHTSTICK
Definition: SDL_gamecontroller.h:312
SDL_CONTROLLER_BINDING_AXIS_TRIGGERLEFT
Definition: controllermap.c:45
SDL_CONTROLLER_BINDING_AXIS_LEFTY_NEGATIVE
Definition: controllermap.c:39
SDL_CONTROLLER_BINDING_AXIS_LEFTX_POSITIVE
Definition: controllermap.c:38
SDL_CONTROLLER_BUTTON_LEFTSHOULDER
Definition: SDL_gamecontroller.h:313
SDL_CONTROLLER_BUTTON_RIGHTSHOULDER
Definition: SDL_gamecontroller.h:314
SDL_CONTROLLER_BUTTON_MAX
Definition: SDL_gamecontroller.h:319
SDL_CONTROLLER_BINDING_AXIS_RIGHTX_POSITIVE
Definition: controllermap.c:42
SDL_CONTROLLER_BINDING_AXIS_RIGHTX_NEGATIVE
Definition: controllermap.c:41
SDL_CONTROLLER_BUTTON_DPAD_UP
Definition: SDL_gamecontroller.h:315
SDL_CONTROLLER_BUTTON_X
Definition: SDL_gamecontroller.h:306
SDL_CONTROLLER_BINDING_AXIS_RIGHTY_NEGATIVE
Definition: controllermap.c:43
SDL_CONTROLLER_BINDING_AXIS_LEFTY_POSITIVE
Definition: controllermap.c:40
SDL_CONTROLLER_BUTTON_DPAD_LEFT
Definition: SDL_gamecontroller.h:317
SDL_CONTROLLER_BUTTON_Y
Definition: SDL_gamecontroller.h:307
SDL_CONTROLLER_BUTTON_LEFTSTICK
Definition: SDL_gamecontroller.h:311
SDL_CONTROLLER_BUTTON_DPAD_DOWN
Definition: SDL_gamecontroller.h:316

Definition at line 86 of file controllermap.c.

Referenced by ConfigureBinding(), SetCurrentBinding(), and WatchJoystick().

## s_arrBindings

SDL_GameControllerExtendedBind s_arrBindings[BINDING_COUNT]

static

Definition at line 138 of file controllermap.c.

## s_bBindingComplete

SDL_bool s_bBindingComplete

static

Definition at line 152 of file controllermap.c.

Referenced by SetCurrentBinding(), and WatchJoystick().

## s_iCurrentBinding

int s_iCurrentBinding

static

Definition at line 150 of file controllermap.c.

Referenced by ConfigureBinding(), SetCurrentBinding(), and WatchJoystick().

## s_nNumAxes

int s_nNumAxes

static

Definition at line 147 of file controllermap.c.

Referenced by SetCurrentBinding(), and WatchJoystick().

## s_unPendingAdvanceTime

Uint32 s_unPendingAdvanceTime

static

Definition at line 151 of file controllermap.c.

Referenced by ConfigureBinding(), SetCurrentBinding(), and WatchJoystick().

## x

int x

Definition at line 54 of file controllermap.c.

## y

int y

Definition at line 54 of file controllermap.c.